//$Id: winamp3Func.cpp,v 1.5 2002/03/18 09:46:58 yoshi Exp $
/*============================================================================

  Winamp3 control class
        copyright (C) 2001,2002 HOSHINO Yoshifumi,(Yoshi)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


% $Log: winamp3Func.cpp,v $
% Revision 1.5  2002/03/18 09:46:58  yoshi
% (none)
%
% Revision 1.4  2002/03/10 10:17:30  yoshi
% (none)
%
% Revision 1.3  2002/01/25 01:23:41  yoshi
% getpath()
%
% Revision 1.1  2002/01/06 10:43:38  yoshi
% created

============================================================================*/

#define WIN32_LEAN_AND_MEAN
#define STRICT
	
#include <tchar.h>
#include <windows.h>
#include "winamp3Func.h"


/******************************************************************************/
/*  class init                                                                */
/******************************************************************************/
CWinamp3Function::CWinamp3Function(LPSTR DefaultStr, LPSTR DefaultPath) : CPlayerDataContainer(WC_WINAMP3, DefaultStr, DefaultPath)
{
}


/******************************************************************************/
/*  get full-path of winamp3                                                  */
/******************************************************************************/
BOOL CWinamp3Function::GetPath(LPSTR AmpPath)
{
  HKEY hkey;
  DWORD dwType = REG_SZ,bufsize=MAX_PATH+1;
  char buffer[MAX_PATH+1];

  if(ERROR_SUCCESS != RegOpenKeyEx(HKEY_CLASSES_ROOT, "Winamp3.File\\shell\\open\\command", 0, KEY_READ, &hkey)){
    strcpy(AmpPath, "");
    return FALSE;
  }

  if(ERROR_SUCCESS != RegQueryValueEx(hkey, NULL, NULL, &dwType, (LPBYTE)buffer, &bufsize)){
    strcpy(AmpPath, "");
    RegCloseKey(hkey);
    return FALSE;
  }

  RegCloseKey(hkey);

  //delete " (0x22)
  *(char *)_tcschr((_TCHAR *)(buffer+1), 0x22) = NULL;
  strncpy(AmpPath, buffer+1, MAX_PATH);

  return TRUE;
}
